/********************************************************
*Classe CurrentPop: qui cre la pop de base servant aux                  *
*simulations. La fonction Generation effectue un cycle                  *
*de reproduction. La fonction Freqall calcule les                              *
*frquences allliques  chaque gnration. La matrice                   *
*d'apparentement "vrai" et estim (Loiselle) sont                              *
*calcules et mises  jour.                                                                     *
**********************************************************/

#include<iostream>
#include<fstream>
#include <math.h>
#include "CurrentPop.hpp"
#include "Locus.hpp"
#include "Params.hpp"
//#include <cstdlib>

CurrentPop::CurrentPop() {  // SDM: mis en private pour verifier qu 'il ne sert pas (pas important)
     length=0; // SDM: ajoute cette ligne
     nullall=0;//ajout le 09/06/08
     Npop=0;
     s=0;
     Nloc=0;
       sigmaA=0;
       sigmaE=0;
     KinshipMatrix=0;
     tpKinshipMatrix=0;
     FreqMatrix=0;
     MargSum=0;
     FreqMatrixQuant=0;
     MargSumQuant=0;

     NlocQuant=0;
   //  FreqAllQuant=0;
    lengthQuant=0;
    popCache = NULL;
    Ngeneration=0;
}
/* LG: CurrentPop est une classe (dfinie ds CurrentPop.hpp) mais aussi une fonction membre (ou methode) de la classe CurrentPop*/
/* LG: fonction dfinie ici sans param () et avec des valeurs initiales a 0*/

//int CurrentPop::Ngeneration = 0;

CurrentPop::CurrentPop(int Ngeneration, int Npop,float s,int Nloc,vector<vector< float > > Freq,Random* random,float sigmaA,float sigmaE ,int NlocQuant/*,float FreqAllQuant*/,vector<float> FreqQuant ){
     int i,j,k;
     lengthQuant=FreqQuant.size();
    /* SDM: length est institue membre pour connaitre le nombre d'alleles */
     this->random=random; /*LG: "this" est un pointeur*/
     this->Npop=Npop;
     this->Nloc=Nloc;
     this->s=s;
       this->sigmaA=sigmaA;
       this->sigmaE=sigmaE;
     this->NlocQuant=NlocQuant;
     NallQuant=lengthQuant;
    this->Ngeneration=Ngeneration;
    g = 0; // compteur de generations
/* SDM: ces fichiers restent ouverts pendant tout l'execution du programme ?
   si c'est le cas et qu'ils deviennent gros, il est possible de vider le tampon d'ecriture regulierement
   vider le tampon ( = flush ) ca signifie ecrire physiquement sur le disque ce qui a ete passe dans write( )
   il ne faut pas multiplier les acces disques, mais d'un autre cote il ne faut pas accumuler trop de donnees dans la memoire vive
   a priori le probleme ne vient pas d'un exces d'utilisation de la memoire mais du nombre d'operation (qund je dis probleme, c'est une facon de parler)
*/
     phenodata.open("phenodata.asd");
     if(!phenodata.is_open()) {cerr<<"cannot create phenodata\n";exit(-1);}
     AddValues.open("AddValues.txt");
     if(!AddValues.is_open()) {cerr<<"cannot create AddValues\n";exit(-1);}

     genofileQuant.open("genofileQuant.txt");
     if(!genofileQuant.is_open()) {cerr<<"cannot create genofileQuant\n";exit(-1);}
     genofileQuant<<"Indiv"<<"\t";
     for (int i=0;i<NlocQuant;i++) genofileQuant << "Loc quanti" << i+1 <<"\t";
     genofileQuant << "\n";

     pop= new Indiv*[Npop]; /*LG: "pop" est un pointeur sur la classe Indiv*/
     popCache = new Indiv*[Npop];
     for(i=0;i<Npop;i++)  {
         pop[i]=new Indiv;
         popCache[i] = NULL;
     }
// ************************************************************************* NX PHENOTYPES ***********
// LG_28/07: tirage des genotypes quanti
    vector<int> vecQuant;
    for(i=0;i<NlocQuant;i++) {
        cout<<"lengthQuant a GO = "<<lengthQuant<<"\n";
        vecQuant.clear();
        for(j=0;j<lengthQuant;j++) {
            for(k=0;k<FreqQuant[j]*2*Npop;k++) vecQuant.push_back(j);
            }
      //    for(k=0;k<2*Npop;k++) vecQuant.push_back(1);
              //  for(k=0;k<FreqAllQuant*2*Npop;k++) vecQuant.push_back(1);  // les locus sont contraints a 2 alleles nomms 1 et 2 en freq FreqAllQuant et 1-FreqAllQuant
              //  for(k=0;k<(1-FreqAllQuant)*2*Npop;k++) vecQuant.push_back(2);
   // }
        for(j=0;j<Npop;j++) {
            int randQuant=random->irand(vecQuant.size()) ;
            pop[j]->SetGenotypesQuant(vecQuant[randQuant],0,i);
            vecQuant.erase(vecQuant.begin()+randQuant);
            int rand2Quant=random->irand(vecQuant.size());
            pop[j]->SetGenotypesQuant(vecQuant[rand2Quant],1,i);
            vecQuant.erase(vecQuant.begin()+rand2Quant);
            }
        }
     for(j=0;j<Npop;j++) {
         genofileQuant<<"Indiv"<<j+1<<"\t";
         for(i=0;i<NlocQuant;i++) {
             genofileQuant << pop[j]->GenotypeQuant[0][i]+1<<pop[j]->GenotypeQuant[1][i]+1<<"\t";
          }
         genofileQuant << "\n";
     }
     genofileQuant << "\n\n";

// ************************************************************************* NX PHENOTYPES ***********
     /*LG: boucle pour tirer les phenotypes */
 //essai avec classe Locus
      //Locus** loc;

    allelequant = new Locus**[NlocQuant];
      for(j=0;j<NlocQuant;j++) {
          allelequant[j] = new Locus* [NallQuant];
             for (k=0;k<NallQuant;k++) {
             allelequant[j][k]=new Locus;
             allelequant[j][k]->SetAllelicEffect(k);
             }
      }
 /*   float addValue[Npop],AllelicEffect[NlocQuant][lengthQuant];    //methode sans classe Locus
    int l;
    for(j=0;j<NlocQuant;j++) {
        cout<<"\n";
        for (k=0;k<lengthQuant;k++) {
            AllelicEffect[j][k]=0;
            AllelicEffect[j][k]=random->nrand(0.,sigmaA);
            cout<<"locus "<<j <<" allele "<<k <<" "<<AllelicEffect[j][k]<<" \t";
        }
    }   */
      float addValue[Npop];
      int l;
      for(i=0;i<Npop;i++) {
        addValue[i]=0;
        for(j=0;j<NlocQuant;j++) {
          // for (l=0;l<2;l++) addValue[i]+=loc[j]->AllelicEffect[j][pop[i]->GenotypeQuant[l][j]];
         //  for (l=0;l<2;l++) addValue[i]+=locus[pop[i]->GenotypeQuant[l][j]]->GetAllelicEffect();
           for (l=0;l<2;l++) addValue[i]+=allelequant[j][pop[i]->GenotypeQuant[l][j]]->GetAllelicEffect();
           pop[i]->SetbreedVal(addValue[i]);
            }
        pop[i]->SetphenVal(pop[i]->getbreedVal()+random->nrand(0.,sigmaE));
        phenodata << i+1 << "\t" << pop[i]->getphenVal() << endl;//impression pop de base
        AddValues << i+1 <<"\t" << pop[i]->getbreedVal() <<endl;
           // <<"\t"<<"allelic effect "<<"\t"<<AllelicEffect[j][0]<< "\t"<<AllelicEffect[j][1]<< "\t"<< pop[i]->GenotypeQuant[0][j]+1<<pop[i]->GenotypeQuant[1][j]+1<<endl;
        }
    phenodata <<"\n\n";
    AddValues <<"\n";

//****************************************************************************************

  /*   for(i=0;i<Npop;i++) {
        // pop[i]=new Indiv;
         pop[i]->SetbreedVal(random->nrand(0.,sigmaA));//breeding values pop de base
         pop[i]->SetphenVal(pop[i]->getbreedVal()+random->nrand(0.,sigmaE));//valeur phno pop de base
         phenodata << i+1 << "\t" << pop[i]->getphenVal() << endl;//impression pop de base
         AddValues << i+1 <<"\t" << pop[i]->getbreedVal() <<endl;
     }
     phenodata <<"\n\n";
     AddValues <<"\n";   */

     vector<int> vecall;
     /*LG: boucle pour tirer les genotypes*/
     for(i=0;i<Nloc;i++) {
         length=Freq[i].size();
          vecall.clear();
        //liste avec 2Npop elements remplie en fonction des frequences avec l'allle 0 ou 1 etc...
         for(j=0;j<length;j++) {
             for(k=0;k<Freq[i][j]*2*Npop;k++) vecall.push_back(j);
         }
          //pour que les individus ne soient pas forcment homozygotes au dpart
         for(j=0;j<Npop;j++) {
             int rand=random->irand(vecall.size()) ;
             pop[j]->SetGenotypes(vecall[rand],0,i);
             vecall.erase(vecall.begin()+rand);
             int rand2=random->irand(vecall.size());
             pop[j]->SetGenotypes(vecall[rand2],1,i);
             vecall.erase(vecall.begin()+rand2);
             }
     }

     KinshipMatrix= (float**) malloc(Npop*sizeof(float*));
     if (!KinshipMatrix) {cerr << "oom" << endl; exit(-1);}
     for (i=0; i<Npop; i++) {
		KinshipMatrix[i]= (float*) malloc(Npop*sizeof(float));
		if (!KinshipMatrix[i]) {cerr << "oom" << endl; exit(-1);}
		for (j=0; j<Npop; j++) KinshipMatrix[i][j]= 0;
		KinshipMatrix[i][i]= 0.5;
	 }

     tpKinshipMatrix= (float**) malloc(Npop*sizeof(float*));
     if (!tpKinshipMatrix) {cerr << "oom" << endl; exit(-1);}
     for (i=0; i<Npop; i++) {
		tpKinshipMatrix[i]= (float*) malloc(Npop*sizeof(float));
		if (!tpKinshipMatrix[i]) {cerr << "oom" << endl; exit(-1);}
		// pas besoin de l'initialiser
	 }

     FreqMatrix= (float**) malloc(Nloc*sizeof(float*));
     if (!FreqMatrix) {cerr << "oom" << endl; exit(-1);}
     for (i=0; i<Nloc; i++) {
		FreqMatrix[i]= (float*) malloc(length*sizeof(float));
		if (!FreqMatrix[i]) {cerr << "oom" << endl; exit(-1);}
		for (j=0; j<length; j++) FreqMatrix[i][j]= 0;  // SDM: on initialise pas avec Freq? je comprends pas tout encore...
     }

     MargSum= (float*) malloc(Nloc*sizeof(float));
     if (!MargSum) {cerr << "oom" << endl; exit(-1); }

     FreqMatrixQuant= (float**) malloc(NlocQuant*sizeof(float*));
     if (!FreqMatrixQuant) {cerr << "oom" << endl; exit(-1);}
     for (i=0; i<NlocQuant; i++) {
		FreqMatrixQuant[i]= (float*) malloc(lengthQuant*sizeof(float));
		if (!FreqMatrixQuant[i]) {cerr << "oom" << endl; exit(-1);}
		for (j=0; j<lengthQuant; j++) FreqMatrixQuant[i][j]= 0;  // SDM: on initialise pas avec Freq? je comprends pas tout encore...
     }

     MargSumQuant= (float*) malloc(NlocQuant*sizeof(float));
     if (!MargSumQuant) {cerr << "oom" << endl; exit(-1); }

     genofile.open("genofile.txt");
     if(!genofile.is_open()) {cerr<<"cannot create genofile\n";exit(-1);}
     for (int i=0;i<Nloc;i++) genofile << "Loc" << i+1 <<"\t";
  /*   genofile << "\n";
     for (int i=0;i<Npop;i++) {
         for (int j=0;j<Nloc;j++) {
            if (pop[i]->Genotype[0][j]+1<10) genofile <<"0"<<pop[i]->Genotype[0][j]+1;
             else genofile << pop[i]->Genotype[0][j]+1;
            if (pop[i]->Genotype[1][j]+1<10) genofile <<"0"<<pop[i]->Genotype[1][j]+1<<"\t";
             else genofile <<pop[i]->Genotype[1][k]+1<<"\t";
         }
         genofile << "\n";
     }
  */   genofile << "\n";

     haplofile.open("haplofile.txt");
     if(!haplofile.is_open()) {cerr<<"cannot create haplofile\n";exit(-1);}

     pedigree.open("simul.ped");
     if(!pedigree.is_open()) {cerr<<"cannot create pedigree\n";exit(-1);}
     pedigree << "Ind\tSire\tDam"<<endl;//lisible par Pedigree Viewer

     ritlandfile.open("ritlandfile.txt");
     if(!ritlandfile.is_open()) {cerr<<"cannot create ritlandfile\n";exit(-1);}
    // for (i=0; i<Npop; i++) {
    //     for (j=0; j<Npop; j++) ritlandfile << Ritland96(i,j) << "\t";
     ritlandfile << "\n";
    // }

     loiselfile.open("loiselfile.txt");
     if(!loiselfile.is_open()) {cerr<<"cannot create loiselfile\n";exit(-1);}
     loiselfile << "\n";

     allelesharingfile.open("allelesharingfile.txt");
     if(!allelesharingfile.is_open()) {cerr<<"cannot create allelesharingfile\n";exit(-1);}
     allelesharingfile << "\n";

     phiAfile.open("phiAfile.txt");
     if(!phiAfile.is_open()) {cerr<<"cannot create phiAfile\n";exit(-1);}

     LoiselleQuantfile.open("LoiselleQuantfile.txt");
     if(!LoiselleQuantfile.is_open()) {cerr<<"cannot create LoiselleQuantfile\n";exit(-1);}
     LoiselleQuantfile << "\n";

     allelesharQuantfile.open("allelesharQuantfile.txt");
     if(!allelesharQuantfile.is_open()) {cerr<<"cannot create allelesharQuantfile\n";exit(-1);}
     allelesharQuantfile << "\n";
   /*  for (i=0; i<Npop; i++) {
         for (j=i+1; j<Npop; j++) APSmoy+=(2*APS(i,j))/(Npop*(Npop-1));
     }
     allelesharingfile << "APSmoy = " << APSmoy << "\n";  */

//     Thomsonfile.open("Thomsonfile.xls");
//     if(!Thomsonfile.is_open()) {cerr<<"cannot create Thomsonfile\n";exit(-1);}
//     Thomsonfile << "\n";

     //mantel.open("mantel.txt");
     //if(!mantel.is_open()) {cerr<<"cannot create mantel\n";exit(-1);}

     //Probfile.open("Qij.xls");
     //if(!Probfile.is_open()) {cerr<<"cannot create Qij\n";exit(-1);}

     acc=0;//valeur initiale du compteur
}

CurrentPop::~CurrentPop(){

    if (FreqMatrix) {
        for (int i=0; i<length; i++) {
            if (FreqMatrix) free(FreqMatrix[i]);
        }
        free(FreqMatrix);
    }
  if (FreqMatrixQuant) {
        for (int i=0; i<lengthQuant; i++) {
            if (FreqMatrixQuant) free(FreqMatrixQuant[i]);
        }
        free(FreqMatrixQuant);
    }

     int i;

    for (i=0;i<NlocQuant; i++) {
        for (int j=0; j<NallQuant; j++) {
            delete allelequant[i][j];
        }
        delete[] allelequant[i];
    }
    delete[] allelequant;

     genofileQuant.close();
     genofile.close();
     haplofile.close();
     pedigree.close();
     phenodata.close();
     AddValues.close();
     ritlandfile.close();
     loiselfile.close();
     allelesharingfile.close();
     phiAfile.close();
     LoiselleQuantfile.close();
     allelesharQuantfile.close();
//     Thomsonfile.close();
     //mantel.close();
     //Probfile.close();

	// SDM: ajoute []... il faut ecrire delete[] quand on a cree avec new [] (ce qui n'empeche pas de delete chaque element comme tu l'as fait plus haut)
     for (i=0;i<Npop;i++) delete pop[i];
     delete [] pop;
     for (i=0;i<Npop;i++) if (popCache[i]) delete popCache[i];
     delete [] popCache;

     // SDM je libere la memoire que j'ai allouee a la place des vectors
     if (KinshipMatrix) {
		for (i=0; i<Npop; i++) if (KinshipMatrix[i]) free(KinshipMatrix[i]);
		free(KinshipMatrix);
	 }
     if (tpKinshipMatrix) {
		for (i=0; i<Npop; i++) if (tpKinshipMatrix[i]) free(tpKinshipMatrix[i]);
		free(tpKinshipMatrix);
	 }
	 if (MargSum) free(MargSum);
	 if (MargSumQuant) free(MargSumQuant);
}


inline int CurrentPop::round (float f) {
    return (int)(f + 0.5);
}


void CurrentPop::Generation() {
     g++; // on incremente le compteur de generations
cout<<"compteur generations: "<<g<<"sur "<<Ngeneration<<"au total"<<endl;
     int i,j,k;
     int motherlist[Npop];//liste des mres
     int fatherlist[Npop];//liste des pres

    // delete all Indiv about to become grandparents
     for (i=0;i<Npop; i++) {
         if (popCache[i]!=NULL) {
             delete popCache[i];
             popCache[i] = NULL;
         }
     }

     Indiv* tamponPop[Npop];
    // vector<vector<float> > tmpKM;//matrice tampon dans laquelle on stocke temporairement les coeff d'apparentement
    // sDM:: je la supprime, remplace par celle au niveau de la classe
//     vector<float> Tmp(Npop,0); // SDM: a priori ca sert a rien
     bool flag;
     for(i=0;i<Npop;i++) tamponPop[i]=new Indiv;//nouvelle pop temporaire
//     tmpKM.resize(Npop,Tmp); SDM: ca sert a rien tpKinshipMatrix est deja de la bonne taille
     acc+=Npop;//compteur incrment pour sortir les individus en numrotation absolue

// *** Tirage des peres et meres et calcul des breedval+phenotype ***
     for(i=0;i<Npop;i++){
         motherlist[i]=random->irand(Npop);//tirage d'une liste donnant les indices des mres
         if (random->uniform()<s) fatherlist[i]=motherlist[i];//id pour pres
         else {
             do fatherlist[i]=random->irand(Npop);
             while (fatherlist[i]==motherlist[i]);
         }
    //     tamponPop[i]->SetbreedVal(0.5*(pop[motherlist[i]]->getbreedVal()+pop[fatherlist[i]]->getbreedVal()));
    //     tamponPop[i]->SetphenVal(tamponPop[i]->getbreedVal()+(random->uniform()*sigmaA)+random->nrand(0.,sigmaE));
         // gamma()
         //on assigne les breeding values et les valeurs phno en fonction de l'identit des parents
     }
// ******************************** Tirage des genotypesQuanti******************
     for (k=0;k<NlocQuant;k++){//on boucle sur les locus en premier
          for (i=0;i<Npop;i++) {//sur les individus
               tamponPop[i]->SetGenotypesQuant(pop[motherlist[i]]->GenotypeQuant[random->irand(2)][k],0,k);
               tamponPop[i]->SetGenotypesQuant(pop[fatherlist[i]]->GenotypeQuant[random->irand(2)][k],1,k);
         }
     }
// ************************************************************************* NX PHENOTYPES ***********
//******************************************************************************************
// *** Tirage des genotypes des i indiv aux k locus ***
     for (k=0;k<Nloc;k++){//on boucle sur les locus en premier
          for (i=0;i<Npop;i++) {//sur les individus
               tamponPop[i]->SetGenotypes(pop[motherlist[i]]->Genotype[random->irand(2)][k],0,k);
               tamponPop[i]->SetGenotypes(pop[fatherlist[i]]->Genotype[random->irand(2)][k],1,k);
             //on fixe les allles du gne k de l'ind i en fonction des allles parentaux (un de ses chromosomes tir au hasard)
         }
     }
// *** teste si les individus de pop ont t parents et supprime ceux qui ne l'ont pas t  ***
     for (i=0;i<Npop;i++) {
        // SDM: flag pas initialise, objets JAMAIS detruits!
        flag= 0;
        for(j=0;j<Npop;j++) if (i==motherlist[j]||i==fatherlist[j]) flag=1;
        if (!flag) delete pop[i];
        else popCache[i] = pop[i];
     }
// *** fournit les pointeurs Pere et Mere ***
     for (i=0;i<Npop;i++) {
          tamponPop[i]->Mere=pop[motherlist[i]];
          tamponPop[i]->Pere=pop[fatherlist[i]];
          tamponPop[i]->Indexfather=fatherlist[i];
          tamponPop[i]->Indexmother=motherlist[i];
     }

// *** edition du PEDIGREE (dans simul.ped) avec numrotation absolue des individus et sans 0 (ASReml) ***
     for(i=0;i<Npop;i++) pedigree << i+1+acc << "\t" << motherlist[i]+acc-Npop+1 <<"\t"<< fatherlist[i]+acc-Npop+1 <<endl;

// *** copie les individus tamponPop dans pop  // SDM: remarque: on copie les adresses uniquement ***
     for (i=0;i<Npop;i++) pop[i]=tamponPop[i];

// SDM: a priori, c'est la dessous que ca commence a se corser
// SDM: ci-dessous, tous les tpKM sont remplaces par tpKinshipMatrix
//***************************************************************************************
   // Construction phenotype a partir de GenotypeQuant
    float addValue[Npop];
    int l;
    for(i=0;i<Npop;i++) {
        addValue[i]=0;
        for(j=0;j<NlocQuant;j++) {
           for (l=0;l<2;l++) addValue[i]+=allelequant[j][pop[i]->GenotypeQuant[l][j]]->GetAllelicEffect();
           pop[i]->SetbreedVal(addValue[i]);
            }
        pop[i]->SetphenVal(pop[i]->getbreedVal()+random->nrand(0.,sigmaE));
        phenodata << i+1 << "\t" << pop[i]->getphenVal() << endl;//impression pop de base
        //for (j=0;j<NlocQuant;j++) {
        //    AlleleEffect << i+1 <<"\t" << pop[i]->getbreedVal()<<"\t"<<"allelic effect "<<"\t"<<allelequant[j][0]->GetAllelicEffect()<< "\t"<<allelequant[j][1]->GetAllelicEffect()<< "\t"<< pop[i]->GenotypeQuant[0][j]+1<<pop[i]->GenotypeQuant[1][j]+1<<endl;
        //}
        AddValues << i+1 <<"\t" << pop[i]->getbreedVal()<<endl;
    }
    phenodata <<"\n\n";
    AddValues <<"\n";
//****************************************************************************************
// *** calcul des coeff d'apparentements entre individus i et j ***

for (i=0;i<Npop;i++) {
          for(j=0;j<Npop;j++) {
              if (i!=j && j>i) {// on remplit ici les cases hors de la diagonale
              tpKinshipMatrix[i][j]=0.25*(KinshipMatrix[pop[i]->Indexfather][pop[j]->Indexmother]+KinshipMatrix[pop[i]->Indexfather][pop[j]->Indexfather]+KinshipMatrix[pop[i]->Indexmother][pop[j]->Indexmother]+KinshipMatrix[pop[i]->Indexmother][pop[j]->Indexfather]);
              }
              else if (j<i)  tpKinshipMatrix[i][j]= tpKinshipMatrix[j][i];
              //cases de la diagonale
              else  tpKinshipMatrix[i][j]=0.5*(1+KinshipMatrix[pop[i]->Indexfather][pop[i]->Indexmother]);
              //on sort le phi(i,i) qui vaut 1/2(1+Fi) Fi coeff d'inbreeding
              }
          }
for (i=0;i<(Npop);i++) {
          for(j=0;j<(Npop);j++) {
              KinshipMatrix[i][j]=/* SDM: ici*/ tpKinshipMatrix[i][j];
              phiAfile << KinshipMatrix[i][j]<<"\t";
          }
          phiAfile <<"\n";
     }
// *** edition PHENODATA et AddValues boucle sur i indiv *** puis GENOFILE et LOISELLE en bouclant sur k locus et j indiv
   //  freqall();//update a chaque generation
freqall();
freqallQuant();

      for(i=0;i<Npop;i++) { //float Qbarre = Qijtot();
         haplofile<<"Indiv"<<i+1<<"\t";
    //     phenodata << i+1+acc << "\t" << pop[i]->getphenVal() <<endl;//on imprime la valeur phenotypique de chaque individu
    //     AddValues << i+1+acc << "\t" << pop[i]->getbreedVal() << endl;//impression des breeding values

      // *** edition GENOFILE boucle sur les k locus ***
         for(k=0;k<Nloc;k++) {
             if (pop[i]->Genotype[0][k]+1<10) genofile <<"0"<<pop[i]->Genotype[0][k]+1;
             else genofile << pop[i]->Genotype[0][k]+1;
             if (pop[i]->Genotype[1][k]+1<10) genofile <<"0"<<pop[i]->Genotype[1][k]+1<<"\t";
             else genofile <<pop[i]->Genotype[1][k]+1<<"\t"; //note: le +1  la ligne du dessus permet de sortir des allles qui ne sont pas considrs commedonne manquante par Genetix ou autre
             if (pop[i]->Genotype[0][k]+1==pop[i]->Genotype[1][k]+1) haplofile<<pop[i]->Genotype[0][k]+1; //note: le +1  la ligne du dessus permet de sortir des allles qui ne sont pas considrs commedonne manquante par Genetix ou autre
             else haplofile<<"hetero"<<"\t";
         }
         genofile << "\n"; //LG: saute une ligne entre chq generation
         haplofile << "\n";
//**************Edition des genotypes quanti*********************************************
       genofileQuant<<"Indiv"<<i+1<<"\t";
       for(k=0;k<NlocQuant;k++) genofileQuant << pop[i]->GenotypeQuant[0][k]+1<<pop[i]->GenotypeQuant[1][k]+1<<"\t";
       genofileQuant << "\n";
      }
//***************************************************************************************

//********************************************************************************************
     // *** edition Matrice loiselle DANS UN SOUS ECHANTILLON!!!, boucle sur les ixj indiv ***

if(g==Ngeneration) {
    cout<<"derniere generation: "<<g<<endl;
    for(i=0;i<Npop;i++) {
         for(j=0;j<Npop;j++) {//impression de la matrice de Loiselle et d'une matrice pour test de Mantel
              loiselfile << Loiselle(i,j) <<"\t";
              ritlandfile << Ritland96(i,j) << "\t";//rajout 09/06/08
              allelesharingfile << APSbis(i,j) << "\t";//rajout 06/04/2010
              LoiselleQuantfile << LoiselleQuant(i,j) <<"\t";
              allelesharQuantfile << APSquant(i,j) << "\t";
         }
         loiselfile<<"\n";
         ritlandfile << "\n"; //saute une ligne apres les Npop indiv (ligne 1 de la matrice
         allelesharingfile << "\n";
         LoiselleQuantfile<<"\n";
         allelesharQuantfile << "\n";
     }
     ritlandfile << "\n" <<endl;
     loiselfile << "\n" <<endl;
     allelesharingfile << "\n" <<endl;
     LoiselleQuantfile<< "\n" <<endl;
     allelesharQuantfile<< "\n" <<endl;
}

phiAfile << "\n"<<endl;
genofile <<"\n\n";
haplofile <<"\n\n";
phenodata <<"\n"<<endl;
AddValues <<"\n"<<endl;
genofileQuant <<"\n\n";
phiAfile.flush(); //SDM: j'ajoute pour le cas ou la matrice resterait dans la memoire
loiselfile.flush();
ritlandfile.flush();
allelesharingfile.flush();
phenodata.flush();
AddValues.flush();
LoiselleQuantfile.flush();
allelesharQuantfile.flush();
}

void CurrentPop::freqall(){     //Je fusionne freqall et GlobalSumFreq
     int i,j,k;
     GlobalSum=0; // SDM ajout
     nullall=0;

     for(k=0;k<Nloc;k++){//boucle sur les locus
        // length=Freq[k].size();
         for(i=0;i<length;i++) FreqMatrix[k][i]=0;//on initialise les cases de Freq  0  //SDM Freq devient FreqMatrix[k]
// *** on remplit FreqMatrix pour le locus k avec le compte des alleles ***
         for(i=0;i<Npop;i++) {//boucle sur les individus
             for(j=0;j<2;j++) {//boucle sur les chromosomes
                 FreqMatrix[k][pop[i]->Genotype[j][k]]++; //LG: on regarde l'indiv 1  Npop au locus 1  Nloc et au chromosome 1 ou 2
             }  //  et on ajoute 1 dans la case de FreqMatrix correspondant  l'allele port
         }
      // sdm cette ligne vient de GloabSumFreq()  (je pourrais utiliser i mais je mets j pour pas foutre la merde, je change juste les i en k
         for (j=0; j<length; j++) GlobalSum+=(FreqMatrix[k][j]/(2*Npop))*(1-FreqMatrix[k][j]/(2*Npop)); //LG:c'est p(1-p)
        // sdm le code ci dessous vient de MargSum()
 /*        unsigned int cmpt=0;
         MargSum[k]=0;
         for(i=0;i<length;i++) {   // SDM size=length
             MargSum[k]+=(FreqMatrix[k][i]/(2*Npop))*(1-FreqMatrix[k][i]/(2*Npop));
             if (FreqMatrix[k][i]==0) {
                 cmpt++;//chaque fois qu'un allle a disparu (drive)
                 //on ne doit plus le compter dans cette somme
                 nullall++;
                 continue;
             }
         }
         if (length-cmpt-1) MargSum[k]/=(2*Npop-1); //length-cmpt=1 qd le locus est fix si >1 MargSum est defini
         else MargSum[k]= 0;//cas ou on passe en argument un locus fix (arbitraire) // SDM cas ou le locus k est fixe
 */
    }
}

float CurrentPop::Loiselle(int ind1, int ind2) {
      int i,j,cmpt1,cmpt2;
      float sumlocus[Nloc];
      float sum=0;

      for(i=0;i<Nloc;i++) {
          sumlocus[i]=0;
          MargSum[i]=0;
          //cout<<"MargSum="<<MargSum[i]<<"\n";
          //cout<<"debut boucle sur le locus "<<i<<"\t";
          for(j=0;j<length;j++) {  // SDM FreqMatrix[i].size() = length (le code doit tre super optimise a cet endroit!
               //cout<<"debut boucle sur l'allele "<<j<<"\t";
              cmpt1=0;
              cmpt2=0;
              if (1-FreqMatrix[i][j]/(2*Npop)<0.000001) continue; //LG:sauter le reste de la boucle si l'allele est fix
              if (pop[ind1]->Genotype[0][i]==j) cmpt1++;
              if (pop[ind1]->Genotype[1][i]==j) cmpt1++;
              if (pop[ind2]->Genotype[0][i]==j) cmpt2++;
              if (pop[ind2]->Genotype[1][i]==j) cmpt2++;
              sumlocus[i]+=(cmpt1/2.-FreqMatrix[i][j]/(2*Npop))*(cmpt2/2.-FreqMatrix[i][j]/(2*Npop));
              MargSum[i]+=((FreqMatrix[i][j]/(2*Npop))*(1-FreqMatrix[i][j]/(2*Npop)))/(2*Npop-1);
           }
          //cout<<"fin boucle sur l'allele "<<j<<"\n";
          if (MargSum[i]!=0) sum+=sumlocus[i]+MargSum[i];//on teste si le locus i en question n'est pas fix
      }
	// cout<<"fin boucle sur les locus"<<"\n";
	// cout<<"return="<<sum/GlobalSum;
	return sum/GlobalSum;
}

/* SDM MargSum est carrement incorpore dans freqall et remplace par un tableau */

//essai de laurene pour Ritland
float CurrentPop::Ritland96(int ind1, int ind2) {
      int i,j,k,l;
      int compteur=0; // nb de locus  fixs =0 au dbut
      //cout<<"0. demarrage boucle ritland"<<"\n";
      //int Delta[Nloc][length][2][Npop]; //Laurene: defini comme un tableau 4 dim
      int Delta[length][Npop];
      //cout<<"0.1 params defined"<<"\n";
      //int Delta2;  //ajout Laurene - dfini par indiv et inclu ds la boucle sur Chr/allele/locus
      // float sum=0;
      float numlocus[Nloc];
      float numallele[length];
      float coef=0;
      int denom=0;
      int ml[Nloc];
      int nullallele2=0;
      for(i=0;i<Nloc;i++) {   //boucle sur les locus
          //acc=0;
            numlocus[i]=0;
            if (MargSum[i]==0) {    //si locus fixe on utilise pas dans le calcul
            compteur++;
            continue;
          }
      // cout<<"1. ok compteur = "<<compteur<<"\n";
             for(j=0;j<length;j++) {  //boucle sur les alleles
                //if (!FreqMatrix[i][j]/(2*Npop)<0.000001)  continue; //allele perdu par drive
                   numallele[j]=0;
                   if (FreqMatrix[i][j]==0) {
                   nullallele2++;
                   continue;
                   }
     // cout<<"2. ok nullallele = "<<nullallele2<<"\n";
                   for (k=0;k<2;k++) for (l=0;l<2;l++) {
                     /* if (pop[ind1]->Genotype[k][i]==j) Delta[i][j][k][ind1]=1;
                      else Delta[i][j][k][ind1]=0;
                      if (pop[ind2]->Genotype[l][i]==j) Delta[i][j][l][ind2]=1;
                      else Delta[i][j][l][ind2]=0;
                      numallele[j]+=Delta[i][j][k][ind1]*Delta[i][j][l][ind2]; */
                      if (pop[ind1]->Genotype[k][i]==j) Delta[j][ind1]=1;
                      else Delta[j][ind1]=0;
                      if (pop[ind2]->Genotype[l][i]==j) Delta[j][ind2]=1;
                      else Delta[j][ind2]=0;
                      numallele[j]+=Delta[j][ind1]*Delta[j][ind2];
                      // sum+=(((cmpt1*cmpt2)/(FreqMatrix[i][j]/(2*Npop))/4)-1);

                      //cout<<"\tfreq\t"<<FreqMatrix[i][j]<<endl;
                      }
                      numlocus[i]+=numallele[j]/(4*FreqMatrix[i][j]/(2*Npop));
                }
      coef+=(numlocus[i]-1);
      ml[i]=length-nullallele2;
      }
      //return sum/((Nloc-compteur)*length-nullall-(Nloc-compteur));
      //return numerateur/((Nloc-compteur)*length-nullall-1);
     //   cout<<"3. ok coef = "<<coef<<"\n";
      for (i=0;i<Nloc;i++) {
          if (MargSum[i]!=0) denom+=ml[i]-1;
          else continue;
      }
      // cout<<"4. ok final = "<<coef/denom<<"\n";
      return coef/denom;
}

 /*float CurrentPop::APS(int ind1,int ind2) {
      int i,j;
      int a[Npop][Npop][Nloc][length];
      float somme=0;
      for(i=0;i<Nloc;i++) {   //boucle sur les locus
         for(j=0;j<length;j++){
            if (pop[ind1]->Genotype[0][i]==j && pop[ind2]->Genotype[0][i]==j && pop[ind1]->Genotype[1][i]==j && pop[ind2]->Genotype[1][i]==j) a[ind1][ind2][i][j]=2;
            else if ((pop[ind1]->Genotype[0][i]==j && pop[ind2]->Genotype[0][i]!=j && pop[ind2]->Genotype[1][i]!=j) || (pop[ind1]->Genotype[1][i]==j && pop[ind2]->Genotype[0][i]!=j && pop[ind2]->Genotype[1][i]!=j) || (pop[ind1]->Genotype[0][i]!=j && pop[ind1]->Genotype[1][i]!=j && pop[ind2]->Genotype[0][i]!=j && pop[ind2]->Genotype[1][i]!=j) || (pop[ind2]->Genotype[0][i]==j && pop[ind1]->Genotype[0][i]!=j && pop[ind1]->Genotype[1][i]!=j) || (pop[ind2]->Genotype[1][i]==j && pop[ind1]->Genotype[0][i]!=j && pop[ind1]->Genotype[1][i]!=j) ) a[ind1][ind2][i][j]=0;
            else a[ind1][ind2][i][j]=1;
            somme+=a[ind1][ind2][i][j];
         }
      }
      return somme/(2*Nloc);
}*/

float CurrentPop::APSbis(int ind1,int ind2) {
    int i,j,cmpt;
      int abis[Npop][Npop];
      float sommebis=0;
      for(i=0;i<Nloc;i++) {   //boucle sur les locus
        for(j=0;j<length;j++) {
            cmpt=0;
            if (pop[ind1]->Genotype[0][i]==j && pop[ind2]->Genotype[0][i]==j) cmpt++;
            if (pop[ind1]->Genotype[1][i]==j && pop[ind2]->Genotype[1][i]==j) cmpt++;
            if (pop[ind1]->Genotype[0][i]==j && pop[ind2]->Genotype[1][i]==j) cmpt++;
            if (pop[ind1]->Genotype[1][i]==j && pop[ind2]->Genotype[0][i]==j) cmpt++;
            switch (cmpt) {
             case 4: abis[ind1][ind2]=2;
                break;
             case 0: abis[ind1][ind2]=0;
                break;
             case 1: abis[ind1][ind2]=1;
                break;
             case 2: abis[ind1][ind2]=1;
                break;
                        }
            sommebis+=abis[ind1][ind2];
            }
      }
      return sommebis/(2*Nloc);
}

/*
float CurrentPop::Thomson(int ind1,int ind2) {
    int i;
    int S[Nloc];
    float Llocus[Nloc];
    float D[9];
   for(i=0;i<Nloc;i++) {
        S[i]=0;
        if (pop[ind1]->Genotype[0][i]==pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[0][i]==pop[ind2]->Genotype[1][i]) S[i]=1;
        if (pop[ind1]->Genotype[0][i]==pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind1]->Genotype[0][i] && pop[ind2]->Genotype[0][i]==pop[ind2]->Genotype[1][i]) S[i]=2;
        if (pop[ind1]->Genotype[0][i]==pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[0][i] && pop[ind2]->Genotype[1][i]!=pop[ind2]->Genotype[0][i]) S[i]=3;
        if (pop[ind1]->Genotype[0][i]==pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[1][i] && pop[ind2]->Genotype[1][i]!=pop[ind2]->Genotype[0][i]) S[i]=3;
        if (pop[ind1]->Genotype[0][i]==pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind1]->Genotype[0][i] && pop[ind2]->Genotype[1][i]!=pop[ind1]->Genotype[0][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i]) S[i]=4;
        if (pop[ind2]->Genotype[0][i]==pop[ind2]->Genotype[1][i]==pop[ind1]->Genotype[0][i] && pop[ind1]->Genotype[1][i]!=pop[ind1]->Genotype[0][i]) S[i]=5;
        if (pop[ind2]->Genotype[0][i]==pop[ind2]->Genotype[1][i]==pop[ind1]->Genotype[1][i] && pop[ind1]->Genotype[1][i]!=pop[ind1]->Genotype[0][i]) S[i]=5;
        if (pop[ind2]->Genotype[0][i]==pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]!=pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[1][i]!=pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i]) S[i]=6;
        if (pop[ind1]->Genotype[0][i]==pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i]) S[i]=7;
        if (pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[0][i]==pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i]) S[i]=7;
        if (pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]==pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[1][i]!=pop[ind2]->Genotype[1][i]) S[i]=8;
        if (pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]!=pop[ind2]->Genotype[0][i]) S[i]=8;
        if (pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[1][i]==pop[ind2]->Genotype[0][i] && pop[ind1]->Genotype[0][i]!=pop[ind2]->Genotype[1][i]) S[i]=8;
        if (pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i] && pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[0][i]==pop[ind2]->Genotype[1][i] && pop[ind1]->Genotype[1][i]!=pop[ind2]->Genotype[0][i]) S[i]=8;
        if (pop[ind1]->Genotype[0][i]!=pop[ind1]->Genotype[1][i]!=pop[ind2]->Genotype[0][i]!=pop[ind2]->Genotype[1][i]) S[i]=9;
        switch (S[i]) {
             case 1: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1]+pow(FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop),2)*(D[2]+D[3]+D[5]+D[7])+pow(FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop),3)*(D[4]+D[6]+D[8])+pow(FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop),4)*D[9];
             case 2: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*FreqMatrix[i][pop[ind2]->Genotype[0][i]]/(2*Npop)*(D[2]+D[4]+D[6]*FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)+D[9]*FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*FreqMatrix[i][pop[ind2]->Genotype[0][i]]/(2*Npop));
             case 3: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1];
             case 4: Llocus[i]=(D[4]+D[9]*FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop))*(FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop))*(FreqMatrix[i][pop[ind2]->Genotype[0][i]]/(2*Npop))*(FreqMatrix[i][pop[ind2]->Genotype[1][i]]/(2*Npop));
             case 5: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1];
             case 6: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1];
             case 7: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1];
             case 8: Llocus[i]=FreqMatrix[i][pop[ind1]->Genotype[0][i]]/(2*Npop)*D[1];
             case 9: Llocus[i]=4*FreqMatrix[i][pop[ind1]->Genotype[0][i]]*FreqMatrix[i][pop[ind1]->Genotype[1][i]]*FreqMatrix[i][pop[ind2]->Genotype[0][i]]*FreqMatrix[i][pop[ind2]->Genotype[1][i]]*D[9]/(2*Npop);
            }
            Llocus[i]*=Llocus[i];
   }
return Llocus[1];
}*/
void CurrentPop::freqallQuant(){
     int i,j,k;
     GlobalSumQuant=0; // SDM ajout
     for(k=0;k<NlocQuant;k++){//boucle sur les locus
        cout<<"lengthQuant ensuite = "<<lengthQuant<<"\n";
         for(i=0;i<lengthQuant;i++) FreqMatrixQuant[k][i]=0;//on initialise les cases de Freq  0  //SDM Freq devient FreqMatrix[k]
         for(i=0;i<Npop;i++) {//boucle sur les individus
             for(j=0;j<2;j++) {//boucle sur les chromosomes
                 FreqMatrixQuant[k][pop[i]->GenotypeQuant[j][k]]++; //LG: on regarde l'indiv 1  Npop au locus 1  Nloc et au chromosome 1 ou 2
             }  //  et on ajoute 1 dans la case de FreqMatrix correspondant  l'allele port
         }
         for (j=0; j<lengthQuant; j++) GlobalSumQuant+=(FreqMatrixQuant[k][j]/(2*Npop))*(1-FreqMatrixQuant[k][j]/(2*Npop)); //LG:c'est p(1-p)
    }
for(k=0;k<NlocQuant;k++){
    for(i=0;i<lengthQuant;i++) cout<<FreqMatrixQuant[k][i]<<"\t";
    cout<<"\n";
}
cout<<"\n";
}
float CurrentPop::LoiselleQuant(int ind1, int ind2) {
      int i,j,cmpt1,cmpt2;
      float sumlocus[NlocQuant];
      float sum=0;
      for(i=0;i<NlocQuant;i++) {
          sumlocus[i]=0;
          MargSumQuant[i]=0;
          for(j=0;j<lengthQuant;j++) {  // SDM FreqMatrix[i].size() = length (le code doit tre super optimise a cet endroit!
              cmpt1=0;
              cmpt2=0;
              if (1-FreqMatrixQuant[i][j]/(2*Npop)<0.000001) continue; //LG:sauter le reste de la boucle si l'allele est fix
              if (pop[ind1]->GenotypeQuant[0][i]==j) cmpt1++;
              if (pop[ind1]->GenotypeQuant[1][i]==j) cmpt1++;
              if (pop[ind2]->GenotypeQuant[0][i]==j) cmpt2++;
              if (pop[ind2]->GenotypeQuant[1][i]==j) cmpt2++;
              sumlocus[i]+=(cmpt1/2.-FreqMatrixQuant[i][j]/(2*Npop))*(cmpt2/2.-FreqMatrixQuant[i][j]/(2*Npop));
              MargSumQuant[i]+=((FreqMatrixQuant[i][j]/(2*Npop))*(1-FreqMatrixQuant[i][j]/(2*Npop)))/(2*Npop-1);
           }
          if (MargSumQuant[i]!=0) sum+=sumlocus[i]+MargSumQuant[i];//on teste si le locus i en question n'est pas fix
      }
	return sum/GlobalSumQuant;
}

float CurrentPop::APSquant(int ind1,int ind2) {
    int i,j,cmpt;
      int abisQuant[Npop][Npop];
      float sommebis=0;
      for(i=0;i<NlocQuant;i++) {   //boucle sur les locus
        for(j=0;j<lengthQuant;j++) {
            cmpt=0;
            if (pop[ind1]->GenotypeQuant[0][i]==j && pop[ind2]->GenotypeQuant[0][i]==j) cmpt++;
            if (pop[ind1]->GenotypeQuant[1][i]==j && pop[ind2]->GenotypeQuant[1][i]==j) cmpt++;
            if (pop[ind1]->GenotypeQuant[0][i]==j && pop[ind2]->GenotypeQuant[1][i]==j) cmpt++;
            if (pop[ind1]->GenotypeQuant[1][i]==j && pop[ind2]->GenotypeQuant[0][i]==j) cmpt++;
            switch (cmpt) {
             case 4: abisQuant[ind1][ind2]=2;
                break;
             case 0: abisQuant[ind1][ind2]=0;
                break;
             case 1: abisQuant[ind1][ind2]=1;
                break;
             case 2: abisQuant[ind1][ind2]=1;
                break;
                        }
            sommebis+=abisQuant[ind1][ind2];
            }
      }
      cout<<"sommebis="<<sommebis<<"\n";
      return sommebis/(2*NlocQuant);
}
